import ogr

from importer import Importer

TABLE_NAME="cross_section_tracks"
PATH="Geodaesie/Querprofile"


class CrosssectionTrack(Importer):

    def getPath(self, base):
        return "%s/%s" % (base, PATH)


    def getTablename(self):
        return TABLE_NAME


    def isGeometryValid(self, geomType):
        return geomType == 2


    def isShapeRelevant(self, name, path):
        return True


    def createNewFeature(self, featureDef, feat, **args):
        newFeat = ogr.Feature(featureDef)
        newFeat.SetGeometry(feat.GetGeometryRef())

        if self.IsFieldSet(feat, "river_id"):
            newFeat.SetField("river_id", feat.GetField("river_id"))
        else:
            newFeat.SetField("river_id", self.river_id)

        if self.IsFieldSet(feat, "KILOMETER"):
            newFeat.SetField("km", feat.GetFieldAsDouble("KILOMETER"))
        elif self.IsFieldSet(feat, "KM"):
            newFeat.SetField("km", feat.GetFieldAsDouble("KM"))
        else:
            return None

        if self.IsFieldSet(feat, "ELEVATION"):
            newFeat.SetField("z", feat.GetFieldAsDouble("ELEVATION"))
        else:
            newFeat.SetField("z", 0)

        return newFeat

